# # Interface: TimeScale<O>

## # Type parameters

Name | Type
--- | ---
`O` | extends `TimeScaleOptions` = `TimeScaleOptions`

## # Hierarchy

- `Scale`<`O`>

  ↳ `TimeScale`

## # Properties

### # active

• `Readonly` active: `boolean`

#### # Inherited from

Scale.active

#### # Defined in

element.d.ts:7
(opens new window)

### # axis

• axis: `string`

#### # Inherited from

Scale.axis

#### # Defined in

index.esm.d.ts:1239
(opens new window)

### # bottom

• bottom: `number`

Bottom edge of the item. Set by layout system and cannot be used in update

#### # Inherited from

Scale.bottom

#### # Defined in

layout.d.ts:41
(opens new window)

### # chart

• `Readonly` chart: `Chart`<keyof `ChartTypeRegistry`, (`number` | `ScatterDataPoint` | `BubbleDataPoint`)[], `unknown`>

#### # Inherited from

Scale.chart

#### # Defined in

index.esm.d.ts:1229
(opens new window)

### # ctx

• `Readonly` ctx: `CanvasRenderingContext2D`

#### # Inherited from

Scale.ctx

#### # Defined in

index.esm.d.ts:1228
(opens new window)

### # fullSize

• fullSize: `boolean`

if true, and the item is horizontal, then push vertical boxes down

#### # Inherited from

Scale.fullSize

#### # Defined in

layout.d.ts:17
(opens new window)

### # height

• height: `number`

Height of item. Must be valid after update()

#### # Inherited from

Scale.height

#### # Defined in

layout.d.ts:25
(opens new window)

### # id

• `Readonly` id: `string`

#### # Inherited from

Scale.id

#### # Defined in

index.esm.d.ts:1226
(opens new window)

### # labelRotation

• labelRotation: `number`

#### # Inherited from

Scale.labelRotation

#### # Defined in

index.esm.d.ts:1240
(opens new window)

### # left

• left: `number`

Left edge of the item. Set by layout system and cannot be used in update

#### # Inherited from

Scale.left

#### # Defined in

layout.d.ts:29
(opens new window)

### # max

• max: `number`

#### # Inherited from

Scale.max

#### # Defined in

index.esm.d.ts:1242
(opens new window)

### # maxHeight

• maxHeight: `number`

#### # Inherited from

Scale.maxHeight

#### # Defined in

index.esm.d.ts:1232
(opens new window)

### # maxWidth

• maxWidth: `number`

#### # Inherited from

Scale.maxWidth

#### # Defined in

index.esm.d.ts:1231
(opens new window)

### # min

• min: `number`

#### # Inherited from

Scale.min

#### # Defined in

index.esm.d.ts:1241
(opens new window)

### # options

• `Readonly` options: `O`

#### # Inherited from

Scale.options

#### # Defined in

element.d.ts:8
(opens new window)

### # paddingBottom

• paddingBottom: `number`

#### # Inherited from

Scale.paddingBottom

#### # Defined in

index.esm.d.ts:1235
(opens new window)

### # paddingLeft

• paddingLeft: `number`

#### # Inherited from

Scale.paddingLeft

#### # Defined in

index.esm.d.ts:1236
(opens new window)

### # paddingRight

• paddingRight: `number`

#### # Inherited from

Scale.paddingRight

#### # Defined in

index.esm.d.ts:1237
(opens new window)

### # paddingTop

• paddingTop: `number`

#### # Inherited from

Scale.paddingTop

#### # Defined in

index.esm.d.ts:1234
(opens new window)

### # position

• position: `LayoutPosition`

The position of the item in the chart layout. Possible values are

#### # Inherited from

Scale.position

#### # Defined in

layout.d.ts:9
(opens new window)

### # right

• right: `number`

Right edge of the item. Set by layout system and cannot be used in update

#### # Inherited from

Scale.right

#### # Defined in

layout.d.ts:37
(opens new window)

### # ticks

• ticks: `Tick`[]

#### # Inherited from

Scale.ticks

#### # Defined in

index.esm.d.ts:1243
(opens new window)

### # top

• top: `number`

Top edge of the item. Set by layout system and cannot be used in update

#### # Inherited from

Scale.top

#### # Defined in

layout.d.ts:33
(opens new window)

### # type

• `Readonly` type: `string`

#### # Inherited from

Scale.type

#### # Defined in

index.esm.d.ts:1227
(opens new window)

### # weight

• weight: `number`

The weight used to sort the item. Higher weights are further away from the chart area

#### # Inherited from

Scale.weight

#### # Defined in

layout.d.ts:13
(opens new window)

### # width

• width: `number`

Width of item. Must be valid after update()

#### # Inherited from

Scale.width

#### # Defined in

layout.d.ts:21
(opens new window)

### # x

• `Readonly` x: `number`

#### # Inherited from

Scale.x

#### # Defined in

element.d.ts:5
(opens new window)

### # y

• `Readonly` y: `number`

#### # Inherited from

Scale.y

#### # Defined in

element.d.ts:6
(opens new window)

## # Methods

### # afterBuildTicks

▸ afterBuildTicks(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.afterBuildTicks

#### # Defined in

index.esm.d.ts:1323
(opens new window)

### # afterCalculateLabelRotation

▸ afterCalculateLabelRotation(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.afterCalculateLabelRotation

#### # Defined in

index.esm.d.ts:1329
(opens new window)

### # afterDataLimits

▸ afterDataLimits(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.afterDataLimits

#### # Defined in

index.esm.d.ts:1320
(opens new window)

### # afterFit

▸ afterFit(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.afterFit

#### # Defined in

index.esm.d.ts:1332
(opens new window)

### # afterSetDimensions

▸ afterSetDimensions(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.afterSetDimensions

#### # Defined in

index.esm.d.ts:1317
(opens new window)

### # afterTickToLabelConversion

▸ afterTickToLabelConversion(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.afterTickToLabelConversion

#### # Defined in

index.esm.d.ts:1326
(opens new window)

### # afterUpdate

▸ afterUpdate(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.afterUpdate

#### # Defined in

index.esm.d.ts:1314
(opens new window)

### # beforeBuildTicks

▸ beforeBuildTicks(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.beforeBuildTicks

#### # Defined in

index.esm.d.ts:1321
(opens new window)

### # beforeCalculateLabelRotation

▸ beforeCalculateLabelRotation(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.beforeCalculateLabelRotation

#### # Defined in

index.esm.d.ts:1327
(opens new window)

### # beforeDataLimits

▸ beforeDataLimits(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.beforeDataLimits

#### # Defined in

index.esm.d.ts:1318
(opens new window)

### # beforeFit

▸ beforeFit(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.beforeFit

#### # Defined in

index.esm.d.ts:1330
(opens new window)

### # beforeLayout

▸ `Optional` beforeLayout(): `void`

Called before the layout process starts

#### # Returns

`void`

#### # Inherited from

Scale.beforeLayout

#### # Defined in

layout.d.ts:46
(opens new window)

### # beforeSetDimensions

▸ beforeSetDimensions(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.beforeSetDimensions

#### # Defined in

index.esm.d.ts:1315
(opens new window)

### # beforeTickToLabelConversion

▸ beforeTickToLabelConversion(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.beforeTickToLabelConversion

#### # Defined in

index.esm.d.ts:1324
(opens new window)

### # beforeUpdate

▸ beforeUpdate(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.beforeUpdate

#### # Defined in

index.esm.d.ts:1312
(opens new window)

### # buildTicks

▸ buildTicks(): `Tick`[]

#### # Returns

`Tick`[]

#### # Inherited from

Scale.buildTicks

#### # Defined in

index.esm.d.ts:1322
(opens new window)

### # calculateLabelRotation

▸ calculateLabelRotation(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.calculateLabelRotation

#### # Defined in

index.esm.d.ts:1328
(opens new window)

### # configure

▸ configure(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.configure

#### # Defined in

index.esm.d.ts:1313
(opens new window)

### # determineDataLimits

▸ determineDataLimits(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.determineDataLimits

#### # Defined in

index.esm.d.ts:1319
(opens new window)

### # draw

▸ draw(`chartArea`): `void`

Draws the element

#### # Parameters

Name | Type
--- | ---
`chartArea` | `ChartArea`

#### # Returns

`void`

#### # Inherited from

Scale.draw

#### # Defined in

layout.d.ts:50
(opens new window)

### # drawGrid

▸ drawGrid(`chartArea`): `void`

#### # Parameters

Name | Type
--- | ---
`chartArea` | `ChartArea`

#### # Returns

`void`

#### # Inherited from

Scale.drawGrid

#### # Defined in

index.esm.d.ts:1248
(opens new window)

### # drawLabels

▸ drawLabels(`chartArea`): `void`

#### # Parameters

Name | Type
--- | ---
`chartArea` | `ChartArea`

#### # Returns

`void`

#### # Inherited from

Scale.drawLabels

#### # Defined in

index.esm.d.ts:1247
(opens new window)

### # drawTitle

▸ drawTitle(`chartArea`): `void`

#### # Parameters

Name | Type
--- | ---
`chartArea` | `ChartArea`

#### # Returns

`void`

#### # Inherited from

Scale.drawTitle

#### # Defined in

index.esm.d.ts:1246
(opens new window)

### # fit

▸ fit(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.fit

#### # Defined in

index.esm.d.ts:1331
(opens new window)

### # generateTickLabels

▸ generateTickLabels(`ticks`): `void`

#### # Parameters

Name | Type
--- | ---
`ticks` | `Tick`[]

#### # Returns

`void`

#### # Inherited from

Scale.generateTickLabels

#### # Defined in

index.esm.d.ts:1325
(opens new window)

### # getBasePixel

▸ getBasePixel(): `number`

Returns the pixel for the minimum chart value The coordinate (0, 0) is at the upper-left corner of the canvas

#### # Returns

`number`

#### # Inherited from

Scale.getBasePixel

#### # Defined in

index.esm.d.ts:1304
(opens new window)

### # getBaseValue

▸ getBaseValue(): `number`

#### # Returns

`number`

#### # Inherited from

Scale.getBaseValue

#### # Defined in

index.esm.d.ts:1298
(opens new window)

### # getDataTimestamps

▸ getDataTimestamps(): `number`[]

#### # Returns

`number`[]

#### # Defined in

index.esm.d.ts:3312
(opens new window)

### # getDecimalForPixel

▸ getDecimalForPixel(`pixel`): `number`

#### # Parameters

Name | Type
--- | ---
`pixel` | `number`

#### # Returns

`number`

#### # Inherited from

Scale.getDecimalForPixel

#### # Defined in

index.esm.d.ts:1254
(opens new window)

### # getLabelForValue

▸ getLabelForValue(`value`): `string`

Used to get the label to display in the tooltip for the given value

#### # Parameters

Name | Type
--- | ---
`value` | `number`

#### # Returns

`string`

#### # Inherited from

Scale.getLabelForValue

#### # Defined in

index.esm.d.ts:1274
(opens new window)

### # getLabelTimestamps

▸ getLabelTimestamps(): `string`[]

#### # Returns

`string`[]

#### # Defined in

index.esm.d.ts:3313
(opens new window)

### # getLabels

▸ getLabels(): `string`[]

#### # Returns

`string`[]

#### # Inherited from

Scale.getLabels

#### # Defined in

index.esm.d.ts:1311
(opens new window)

### # getLineWidthForValue

▸ getLineWidthForValue(`value`): `number`

Returns the grid line width at given value

#### # Parameters

Name | Type
--- | ---
`value` | `number`

#### # Returns

`number`

#### # Inherited from

Scale.getLineWidthForValue

#### # Defined in

index.esm.d.ts:1279
(opens new window)

### # getMatchingVisibleMetas

▸ getMatchingVisibleMetas(`type?`): `ChartMeta`<`Element`<`AnyObject`, `AnyObject`>, `Element`<`AnyObject`, `AnyObject`>, keyof `ChartTypeRegistry`>[]

#### # Parameters

Name | Type
--- | ---
`type?` | `string`

#### # Returns

`ChartMeta`<`Element`<`AnyObject`, `AnyObject`>, `Element`<`AnyObject`, `AnyObject`>, keyof `ChartTypeRegistry`>[]

#### # Inherited from

Scale.getMatchingVisibleMetas

#### # Defined in

index.esm.d.ts:1244
(opens new window)

### # getMinMax

▸ getMinMax(`canStack`): `Object`

#### # Parameters

Name | Type
--- | ---
`canStack` | `boolean`

#### # Returns

`Object`

Name | Type
--- | ---
`max` | `number`
`min` | `number`

#### # Inherited from

Scale.getMinMax

#### # Defined in

index.esm.d.ts:1309
(opens new window)

### # getPadding

▸ `Optional` getPadding(): `ChartArea`

Returns an object with padding on the edges

#### # Returns

`ChartArea`

#### # Inherited from

Scale.getPadding

#### # Defined in

layout.d.ts:54
(opens new window)

### # getPixelForDecimal

▸ getPixelForDecimal(`decimal`): `number`

Utility for getting the pixel location of a percentage of scale The coordinate (0, 0) is at the upper-left corner of the canvas

#### # Parameters

Name | Type
--- | ---
`decimal` | `number`

#### # Returns

`number`

#### # Inherited from

Scale.getPixelForDecimal

#### # Defined in

index.esm.d.ts:1261
(opens new window)

### # getPixelForTick

▸ getPixelForTick(`index`): `number`

Returns the location of the tick at the given index The coordinate (0, 0) is at the upper-left corner of the canvas

#### # Parameters

Name | Type
--- | ---
`index` | `number`

#### # Returns

`number`

#### # Inherited from

Scale.getPixelForTick

#### # Defined in

index.esm.d.ts:1268
(opens new window)

### # getPixelForValue

▸ getPixelForValue(`value`, `index?`): `number`

Returns the location of the given data point. Value can either be an index or a numerical value The coordinate (0, 0) is at the upper-left corner of the canvas

#### # Parameters

Name | Type
--- | ---
`value` | `number`
`index?` | `number`

#### # Returns

`number`

#### # Inherited from

Scale.getPixelForValue

#### # Defined in

index.esm.d.ts:1288
(opens new window)

### # getProps

▸ getProps<`P`>(`props`, `final?`): `Pick`<`unknown`, `P`[`number`]>

#### # Type parameters

Name | Type
--- | ---
`P` | extends `never`[]

#### # Parameters

Name | Type
--- | ---
`props` | `P`
`final?` | `boolean`

#### # Returns

`Pick`<`unknown`, `P`[`number`]>

#### # Inherited from

Scale.getProps

#### # Defined in

element.d.ts:12
(opens new window)

### # getTicks

▸ getTicks(): `Tick`[]

#### # Returns

`Tick`[]

#### # Inherited from

Scale.getTicks

#### # Defined in

index.esm.d.ts:1310
(opens new window)

### # getUserBounds

▸ getUserBounds(): `Object`

#### # Returns

`Object`

Name | Type
--- | ---
`max` | `number`
`maxDefined` | `boolean`
`min` | `number`
`minDefined` | `boolean`

#### # Inherited from

Scale.getUserBounds

#### # Defined in

index.esm.d.ts:1308
(opens new window)

### # getValueForPixel

▸ getValueForPixel(`pixel`): `number`

Used to get the data value from a given pixel. This is the inverse of getPixelForValue The coordinate (0, 0) is at the upper-left corner of the canvas

#### # Parameters

Name | Type
--- | ---
`pixel` | `number`

#### # Returns

`number`

#### # Inherited from

Scale.getValueForPixel

#### # Defined in

index.esm.d.ts:1296
(opens new window)

### # hasValue

▸ hasValue(): `boolean`

#### # Returns

`boolean`

#### # Inherited from

Scale.hasValue

#### # Defined in

element.d.ts:11
(opens new window)

### # init

▸ init(`options`): `void`

#### # Parameters

Name | Type
--- | ---
`options` | `O`

#### # Returns

`void`

#### # Inherited from

Scale.init

#### # Defined in

index.esm.d.ts:1306
(opens new window)

### # isFullSize

▸ isFullSize(): `boolean`

#### # Returns

`boolean`

#### # Inherited from

Scale.isFullSize

#### # Defined in

index.esm.d.ts:1334
(opens new window)

### # isHorizontal

▸ isHorizontal(): `boolean`

returns true if the layout item is horizontal (ie. top or bottom)

#### # Returns

`boolean`

#### # Inherited from

Scale.isHorizontal

#### # Defined in

layout.d.ts:58
(opens new window)

### # normalize

▸ normalize(`values`): `number`[]

#### # Parameters

Name | Type
--- | ---
`values` | `number`[]

#### # Returns

`number`[]

#### # Defined in

index.esm.d.ts:3314
(opens new window)

### # parse

▸ parse(`raw`, `index`): `unknown`

#### # Parameters

Name | Type
--- | ---
`raw` | `unknown`
`index` | `number`

#### # Returns

`unknown`

#### # Inherited from

Scale.parse

#### # Defined in

index.esm.d.ts:1307
(opens new window)

### # setDimensions

▸ setDimensions(): `void`

#### # Returns

`void`

#### # Inherited from

Scale.setDimensions

#### # Defined in

index.esm.d.ts:1316
(opens new window)

### # tooltipPosition

▸ tooltipPosition(`useFinalPosition?`): `Point`

#### # Parameters

Name | Type
--- | ---
`useFinalPosition?` | `boolean`

#### # Returns

`Point`

#### # Inherited from

Scale.tooltipPosition

#### # Defined in

element.d.ts:10
(opens new window)

### # update

▸ update(`width`, `height`, `margins?`): `void`

Takes two parameters: width and height.

#### # Parameters

Name | Type
--- | ---
`width` | `number`
`height` | `number`
`margins?` | `ChartArea`

#### # Returns

`void`

#### # Inherited from

Scale.update

#### # Defined in

layout.d.ts:64
(opens new window)